【Codeforces Round#279 Div.2】B. Queue

这题看别人的。就是那么诚实。http://www.cnblogs.com/zhyfzy/p/4117481.html

B. Queue

During the lunch break all n Berland State University students lined up in the food court. However, it turned out that the food court, too, has a lunch break and it temporarily stopped working.

Standing in a queue that isn‘t being served is so boring! So, each of the students wrote down the number of the student ID of the student that stands in line directly in front of him, and the student that stands in line directly behind him.(话说题意理解错是怎么过前三个样例的...) If no one stands before or after a student (that is, he is the first one or the last one), then he writes down number 0 instead (in Berland State University student IDs are numerated from 1).

After that, all the students went about their business. When they returned, they found out that restoring the queue is not such an easy task.

Help the students to restore the state of the queue by the numbers of the student ID‘s of their neighbors in the queue.

Input

The first line contains integer n (2 ≤ n ≤ 2·105) — the number of students in the queue.

Then n lines follow, i-th line contains the pair of integers ai, bi (0 ≤ ai, bi ≤ 106), where ai is the ID number of a person in front of a student and bi is the ID number of a person behind a student. The lines are given in the arbitrary order. Value 0 is given instead of a neighbor‘s ID number if the neighbor doesn‘t exist.

The ID numbers of all students are distinct. It is guaranteed that the records correspond too the queue where all the students stand in some order.

Output

Print a sequence of n integers x1, x2, ..., xn — the sequence of ID numbers of all the students in the order they go in the queue from the first student to the last one.

Sample test(s)

input

492 310 731 07 141

output

92 7 31 141 

Note

The picture illustrates the queue for the first sample.

                                        

附代码(当然也是人家的。0。0)

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstdlib>
 4 using namespace std;
 5 const int maxn = 1000010;
 6 int stu[maxn][2], l[maxn], r[maxn];
 7 int line[maxn];
 8 int main()
 9 {
10     //freopen("in.txt", "r", stdin);
11     int n;
12     scanf("%d", &n);
13     for(int i = 0; i < n; i++)
14     {
15         scanf("%d%d", &l[i], &r[i]);
16         stu[r[i]][0] = l[i];
17         stu[l[i]][1] = r[i];
18     }
19     int j, i;
20     /*找出偶数位的人,并将确定位置的人的值设为-1*/
21     for(i = stu[0][1], j = 2; i; j+=2)
22     {
23         line[j] = i;
24         int tmp = stu[i][1];
25         stu[i][0] = -1;    stu[i][1] = -1;
26         i = tmp;
27     }
28     /*根据前前位为0找第一个奇数; 开始此处不理解,其实就是在定义的时候已经把第一个奇数的前前位设为0了,而第一个偶数的前前位经上面步骤变为-1,故不会引起冲突*/
29     for(int k = 0; k < n; k++)
30     {
31         if(!stu[l[k]][0])   {i = l[k];  break;}
32     }
33     /*找奇数*/
34     for(j = 1; i; j+=2)
35     {
36         line[j] = i;
37         i = stu[i][1];
38     }
39     for(int l = 1; l <= n; l++) {if(l != 1) printf(" ");    printf("%d", line[l]);}
40     printf("\n");
41     return 0;
42 }

难道只能当一题党吗。

时间: 2024-10-11 07:10:18

【Codeforces Round#279 Div.2】B. Queue的相关文章

【Codeforces Round #404 (Div. 2)】题解

A. Anton and Polyhedrons 直接统计+答案就可以了. #include<cstdio> #include<cstring> #include<algorithm> #include<cmath> #define maxn 1000 #define LL long long using namespace std; char s[10000]; int main() { int n; LL sum=0; scanf("%d&qu

【Codeforces Round #518 (Div. 2)】

A:https://www.cnblogs.com/myx12345/p/9847588.html B:https://www.cnblogs.com/myx12345/p/9847590.html C: D: E: F: 原文地址:https://www.cnblogs.com/myx12345/p/9847591.html

【Codeforces Round #575 (Div. 3) 】 RGB Substring (hard version) ( FFT)

D2. RGB Substring (hard version) time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output The only difference between easy and hard versions is the size of the input. You are given a string ss cons

Codeforces Round #279 (Div. 2) b

/**  * @brief Codeforces Round #279 (Div. 2) b  * @file b.cpp  * @author mianma  * @created 2014/11/27 15:29  * @edited  2014/11/27 20:40  * @type   * @note  */ #include <cstdio> #include <stack> #include <cstring> #include <vector>

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #279 (Div. 2) a

/**  * @brief Codeforces Round #279 (Div. 2) a  * @file a.cpp  * @author 面码  * @created 2014/11/26 17:05  * @edited  2014/11/26 17:05  * @type   *  */ #include <cstdio> #include <stack> #include <cstring> using namespace std; #define max

Codeforces Round #279 (Div. 2) d

/**  * @brief Codeforces Round #279 (Div. 2) d  * @file d.cpp  * @author 面码  * @created 2014/12/09 10:58  * @edited  2014/12/09 10:58  * @type math greedy  * @note 自己的AC不了,参考别人的,重点是2和3都是质数,所以可以使用贪心求解.  */ #include <fstream> #include <iostream>

【Codeforces Round #446 (Div. 2) A】Greed

[链接] 我是链接,点我呀:) [题意] 在这里输入题意 [题解] 贪心选容量大的瓶子就好 [代码] #include <bits/stdc++.h> #define int long long using namespace std; const int N = 1e5; int n; int a[N+10],b[N+10]; main(){ #ifdef LOCAL_DEFINE freopen("F:\\c++source\\rush_in.txt", "r

【Codeforces Round #446 (Div. 2) C】Pride

[链接] 我是链接,点我呀:) [题意] 在这里输入题意 [题解] 想一下,感觉最后的结果肯定是从某一段开始,这一段的gcd为1,然后向左和向右扩散的. 则枚举那一段在哪个地方. 我们设这一段中所有的数字都做了一次gcd. 假设在i..j这一段. 则求gcd的顺序是(i,i+1),(i+1,i+2)...(j-1,j) 这样a[j]=gcd(a[i],a[i+1]..a[j])了 即顺序求了一遍gcd. 这样,预处理一下i到j的gcd. 如果gcd[i][j]==1,则获取到一个可行方案. 求一